.TH LogitB 1 " " " " "CiudadSim Function"
.SH NAME
LogitB  - Logit equilibrium ( Bell Method )
.SH CALLING SEQUENCE
.nf
[F]=LogitB(A,D,theta)
.fi
.SH PARAMETERS
.TP 10
A
: nxn nodesxnodes matrix of travel times
.TP 10
D
: nxn nodesxnodes matrix of demand flows 
.TP 10
theta
: stochasticity parameter 
.TP 10
F
: nxn nodesxnodes assigned flow matrix
.SH DESCRIPTION
Compute the logit traffic assignment by the Bell
method where all the routes are considered not
only the efficient ones (see LogitD).

To each route r on the graph defined by the 
matrix A is associated a weight exp(-theta*l) 
where l denotes the the total travel time on
the route r. The flow for each demand defined by the matrix D
is assigned on a route proportionnaly to its wheight.

The graph must be strongly connected.
If it is not the case we can add artificial 
arcs with large travel time in such a way that
the new graph becomes strongly connected.

theta must be large enough to insure that the
weight of routes with an infinite number of links
are finite.

.SH EXAMPLES
.nf
// Graph generation (the graph must be stongly connected),
// n is the number of nodes, m the number of arcs.
n=10; m=40; 
c1=m/(n*n);
A=sprand(n,n,c1)+diag(sparse(ones(n-1,1)),1);
A(n,1)=1;A=A-diag(diag(A));
// Demand generation, p is the number of demand.
p=30; c2=p/(n*n);D=sprand(n,n,c2);D=D-diag(diag(D));
//theta definition (almost determinsitic)
theta=10;
// Flow calculation
FD=LogitB(A,D,theta)
.SH SEE ALSO
LogitD,
LogitMB,
LogitMD,
LogitN,
LogitNE,
TrafficAssig
