.TH LogitD 1 " " " " "CiudadSim Function"
.SH NAME
LogitD  - Logit equilibrium ( Dial Method )
.SH CALLING SEQUENCE
.nf
[F]=LogitD(A,D,theta)
.fi
.SH PARAMETERS
.TP 10
A
: nxn nodesxnodes matrix of travel times
.TP 10
D
: nxn nodesxnodes matrix of demand flows 
.TP 10
theta
: stochasticity parameter 
.TP 10
F
: nxn nodesxnodes assigned flow matrix
.SH DESCRIPTION
Compute the logit traffic assignment by the Dial
method where efficient routes are the ones which
never go back towards the origine.

To each efficient route r on the graph defined by the 
matrix A is associated a weight exp(-theta*l) 
where l denotes the the total travel time on
the route r. The flow for each demand defined by the matrix D
is assigned on a route proportionnaly to its wheight.

The graph must be strongly connected.
If it is not the case we can add artificial 
arcs with large travel time in such a way that
the new graph becomes strongly connected.

.SH EXAMPLES
.nf
// Graph generation (the graph must be stongly connected),
// n is the number of nodes, m the number of arcs.
n=10; m=40; 
c1=m/(n*n);
A=sprand(n,n,c1)+diag(sparse(ones(n-1,1)),1);
A(n,1)=1;A=A-diag(diag(A));
// Demand generation, p is the number of demand.
p=30; c2=p/(n*n);D=sprand(n,n,c2);D=D-diag(diag(D));
//theta definition (almost determinsitic)
theta=10
// Flow calculation
FD=LogitD(A,D,theta)
.SH SEE ALSO
LogitB,
LogitMB,
LogitMD,
LogitN,
LogitNE,
TrafficAssig
