.TH MakeNet  1 " " " " "Traffic-toolbox Function"
.SH NAME
MakeNet  -  Makes a net list
.SH CALLING SEQUENCE
.nf
net=MakeNet(nn,nx,ny,tl,hl,nf,lpp,td,hd,demand)
.fi
.SH PARAMETERS
.TP 10
nn
: integer, the number of nodes in the net
.TP 10
nx
: row vector, x coordinates of the nodes
.TP 10
ny
: row vector, y coordinates of the nodes
.TP 10
tl
: row vector, tail nodes numbers of the links
.TP 10
hl
: row vector, head nodes numbers of the links
.TP 10
nf
: integer between 0 and 6, travel time function formula
.TP 10
lpp
: 4 x nl matrix, travel time function parameters, where nl is the number of links 
.TP 10
td
: row vector, tail nodes numbers of the demands (its size
is the number of commodities)
.TP 10
hd
: row vector, head nodes numbers of the demands
.TP 10
demand
: row vector, demand flows
.TP 10
net
: a NetList


.SH DESCRIPTION
MakeNet makes a net list according to its arguments.
.SH EXAMPLES
.nf
// Coordinates for the nodes
nx=[500 10 500 900]
ny=[10 300 600 300]
// tail and head vectors for the links
tl=[1 2 3 1 1 3]
hl=[2 3 4 4 3 1]
// link-performance-function parameters
lpp=[1 1 1 1 1 1;1 3 5 2 7 1;1 2 1 2 1 2;2 2 2 2 2 2];
// Creation of the traffic net
%net=MakeNet(4,nx,ny,tl,hl,6,lpp,1,3,10);
// We can see it with
ShowNet()

.fi
.SH SEE ALSO
NetList,
ShowNet





