.TH RandomNNet  1 " " " " "Traffic-toolbox Function"
.SH NAME
RandomNNet  -  Random generation of traffic network data
.SH CALLING SEQUENCE
.nf
net=RandomNNet(nn,mna,var,nd,nf)
.fi
.SH PARAMETERS
.TP 10
nn
: number of nodes
.TP 10
mna
: mean value of the exterior degree of each node (numbers of leaving arcs)
.TP 10
var
: variance of the exterior degree of each node
.TP 10
nd
: number of OD-pairs (origin-destination)
.TP 10
nf
: model chosen for the computation of the travel time
.TP 10
net
: resulting network

.SH DESCRIPTION
Generates randomly the data for the Traffic Assignment Problem. For each node an
exterior degree is chosen randomly with a normal distribution of mean mna
and variance var, then the successors are chosen without
repetition. The value of nf indicates the formula chosen for the computation of
the travel time, by default it is 6. This way of generating randomly the net if very much
slower than RandomNet.

.SH EXAMPLES
.nf
%net=RandomNNet(3,3,1,2);
// generates a network with 3 nodes,2 OD-pairs and form
// each node the number of leaving arcs is normally dis-
// tributed with mean 3 and var 1
ShowNet();
.fi
.SH SEE ALSO
IntroTrfAsg,
RandomNet,
Regular,
NetList,
ShowNet


