.TH MSASUE  1 " " " " "Traffic-toolbox Function"
.SH NAME
MSASUE  -  MSA algorithm for Stochastic User Equilibrium
.SH CALLING SEQUENCE
.nf
[f,ta,ben]=MSASUE(net,beta,kmax,tol)
.fi

.SH PARAMETERS
.TP 10
net
: a NetList 
.TP 10
beta
: variance of the perceived travel time over a road segment of unit travel time
.TP 10
kmax
: maximum number of iterations
.TP 10
tol
: precision
.TP 10
f
: assigned flow (disaggregated by commodity)
.TP 10
ta
: link travel time for the assigned flow f
.TP 10
ben
: ni x 5 matrix (ni number of performed general iterations) benchmark
information

.SH DESCRIPTION
Assigns the flow with a MSA heuristic using a Probit-based model in each
iteration. After an initial Probit assignment the links costs are updated and 
a new Probit assignment is computed using flow dependent travel times. 
The new flow, f^k+1=(1-lk)*f^k+lk*y^k, where lk=1/k, is computed as a
combination of the previous flow f^k and a Probit assignment y^K.
This is repeated iteratively until iteration kmax or until the precision is reached.

The matrix ben contains intermediary informations on the
algorithm. For each iteration it gives the iteration number, time
spent, cost, memory used and an convergence error evaluation.

.SH EXAMPLES
.nf
net=TrafficExample("Small");
[f,s,ben]=MSASUE(net,1,15,1e-3);

.fi
.SH SEE ALSO
Probit,
MSA,
FW,
DSD,
TrafficAssig





