function [X,Y,gama]=fullstate(A,B1,B2,C1,D12,D11)
// Copyright INRIA
// Generated by lmitool on Thu Feb 09 11:30:44 MET 1995
  
  Mbound = 1e3;
  abstol = 1e-10;
  nu = 10;
  maxiters = 100;
  reltol = 1e-10;
  options=[Mbound,abstol,nu,maxiters,reltol];
  
  ///////////DEFINE INITIAL GUESS AND PRELIMINARY CALCULATIONS BELOW
  X_init=eye(A)                                                     
  Y_init=zeros(B2');                                                
  gama_init=1                                                       
  I1=eye(B1'*B1);I2=eye(C1*C1');                                    
  /////////// 
  
  XLIST0=list(X_init,Y_init,gama_init)
  XLIST=lmisolver(XLIST0,fullstate_eval,options)
  [X,Y,gama]=XLIST(:)
endfunction


/////////////////EVALUATION FUNCTION////////////////////////////

function [LME,LMI,OBJ]=fullstate_eval(XLIST)
  [X,Y,gama]=XLIST(:)
  
  /////////////////DEFINE LME, LMI and OBJ BELOW
  LME=X-X' ;                                                        
  LMI=-[A*X+X*A'+B2*Y+Y'*B2',B1,X*C1'+Y'*D12';                      
	B1',-gama*I1,D11';                                                
	C1*X+D12*Y,D11,-gama*I2]                                          
  OBJ=gama                                                          
endfunction

